------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with ada.text_io;

with core;

package action is

                                             ------------------------------------------------------------------------------------------

	procedure game_idle;

	type procedure_pointer is access procedure;
	type mememe is mod (2 ** 8);
	type list_type         is array (mememe) of procedure_pointer;

                                             ------------------------------------------------------------------------------------------

	active : boolean   := true;
	signal : character := ' ';

	list : list_type := (others => game_idle'access);

                                             ------------------------------------------------------------------------------------------

	procedure scan;

	procedure bind (symbol : character         := core.cancel;
	                mimimi : procedure_pointer := game_idle'access);

	procedure unbind (symbol : character := core.cancel);

	procedure game_exit;

                                             ------------------------------------------------------------------------------------------

end action;
