------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package ammunition is

                                             ------------------------------------------------------------------------------------------

	type list is (
		arrows,             bolts,              slingshots,         jarids
	);

	type mark is mod 72;

                                             ------------------------------------------------------------------------------------------

	type constant_type is new core.constant_type with
	record
		value          : natural := 0;
		weight         : natural := 0;
		dual_wield     : boolean := false;
		amount_limit   : natural := 0;
		attack_range   : natural := 0;
		distance_range : natural := 0;
	end record;

	type variable_type is new core.variable_type with
	record
		amount      : natural := 0;
		enchantment : natural := 0;
	end record;

	type constant_list is array (list) of constant_type;
	type variable_list is array (mark) of variable_type;

                                             ------------------------------------------------------------------------------------------

	constant_data : constant constant_list := (
		(core.ammunition, "Arrows              ", '^', core.colour.red, core.effect.normal, 11, 13, false, 23,  7, 67),
		(core.ammunition, "Bolts               ", '^', core.colour.red, core.effect.normal, 13, 23, false, 29,  5, 67),
		(core.ammunition, "Slingshots          ", '^', core.colour.red, core.effect.normal,  5,  7, true,  43,  7, 67),
		(core.ammunition, "Jarids              ", '^', core.colour.red, core.effect.normal, 29, 37, true,   7,  7, 67)
	);

	variable_data : variable_list;

                                             ------------------------------------------------------------------------------------------

	procedure generate;
	procedure render;

                                             ------------------------------------------------------------------------------------------

end ammunition;
