------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package armour is

                                             ------------------------------------------------------------------------------------------

	type list is (
		iron_helmet,        iron_chestplate,    iron_gauntlets,     iron_greaves,       iron_cuisse,        iron_fauld,         iron_gardbrace,     iron_rerebrace
	);

	type mark is mod 72;

                                             ------------------------------------------------------------------------------------------

	type constant_type is new core.constant_type with
	record
		value         : natural := 0;
		weight        : natural := 0;
		defense_range : natural := 0;
	end record;

	type variable_type is new core.variable_type with
	record
		enchantment : natural := 0;
		condition   : natural := 0;
	end record;

	type constant_list is array (list) of constant_type;
	type variable_list is array (mark) of variable_type;

                                             ------------------------------------------------------------------------------------------

	constant_data : constant constant_list := (
		(core.armour, "Iron Helmet         ", 'm', core.colour.yellow, core.effect.normal, 11, 31,  7),
		(core.armour, "Iron Chestplate     ", 'M', core.colour.yellow, core.effect.bold,   23, 67, 11),
		(core.armour, "Iron Gauntlets      ", 'i', core.colour.yellow, core.effect.normal, 13, 43,  7),
		(core.armour, "Iron Greaves        ", 'I', core.colour.yellow, core.effect.normal, 19, 73, 13),
		(core.armour, "Iron Cuisse         ", 'Y', core.colour.yellow, core.effect.bold,   17, 53, 10),
		(core.armour, "Iron Fauld          ", '-', core.colour.yellow, core.effect.normal, 13, 37,  3),
		(core.armour, "Iron Gardbrace      ", 'v', core.colour.yellow, core.effect.normal, 11, 41,  8),
		(core.armour, "Iron Rerebrace      ", 'V', core.colour.yellow, core.effect.normal, 13, 47,  7)
	);

	variable_data : variable_list;

                                             ------------------------------------------------------------------------------------------

	procedure generate;
	procedure render;

                                             ------------------------------------------------------------------------------------------

end armour;
