------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package game is

                                             ------------------------------------------------------------------------------------------

	type trait_list is (
		trait_strength,     trait_perception,   trait_edurance,     trait_charisma,     trait_intelligence, trait_agility,      trait_luck,         trait_autism
	);

	type skill_list is (
		-- combat skills.
		skill_blades,       skill_axes,         skill_maces,        skill_polearms,     skill_shields,      skill_bows,         skill_crossbows,    skill_hands,
		skill_onehanded,    skill_twohanded,    skill_precision,    skill_thrust,       skill_athletics,    skill_equitation,   skill_tactics,      skill_skirmish,
		-- magic skills.
		skill_fire_magic,   skill_water_magic,  skill_earth_magic,  skill_wind_magic,   skill_nature_magic, skill_venom_magic,  skill_shadow_magic, skill_bone_magic,
		skill_rune_magic,   skill_puppet_magic, skill_summon_magic, skill_insect_magic, skill_ritual_magic, skill_rot_magic,    skill_tabboo_magic, skill_abyss_magic,
		-- trait skills.
		skill_wisdom,       skill_patience,     skill_religion,     skill_speech,       skill_reflection,   skill_refraction,   skill_authority,    skill_deception,
		skill_life_force,   skill_mana_force,   skill_regeneration, skill_restoration,  skill_spellcraft,   skill_protection,   skill_synthesis,    skill_evocation,
		-- knowledge skills.
		skill_medicine,     skill_mercantile,   skill_education,    skill_navigation,   skill_conjuration,  skill_alteration,   skill_enchanement,  skill_teleportation,
		skill_astronomy,    skill_occultism,    skill_mysticism,    skill_survival,     skill_evasion,      skill_stealth,      skill_detection,    skill_identification,
		-- work skills.
		skill_blacksmith,   skill_whitesmith,   skill_light_craft,  skill_heavy_craft,  skill_light_works,  skill_heavy_works,  skill_leather,      skill_construction,
		skill_weapons,      skill_armours,      skill_engineer,     skill_alchemy,      skill_ritual,       skill_experience,   skill_necromancy,   skill_reincarnation
	);

	type title_list is (
		title_hero,         title_demon_lord,   title_dragon_slayer,title_goblin_slayer
	);

                                             ------------------------------------------------------------------------------------------

	trait_info : constant array (trait_list) of core.description := (
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                "
	);

	-- Trying out descriptions, this adds nothing to gameplay really, might even remove this shit, for now it's bad and unaligned...
	skill_info : constant array (skill_list) of core.description := (
		"Blades: Master the art of wielding sharp-edged weapons like swords and daggers to deliver swift and precise strikes.                            ",
		"Axes: Become adept at swinging heavy battle axes and hatchets, crushing your enemies with sheer brute force.                                    ",
		"Maces: Hone your skill with blunt weapons like maces and hammers, shattering bones and armor with powerful blows.                               ",
		"Polearms: Command long-reaching weapons like spears and halberds, keeping your foes at bay with deadly thrusts and sweeps.                      ",
		"Shields: Learn to effectively block and parry incoming attacks using different types of shields, ensuring your defense remains intact.          ",
		"Bows: Master the art of archery, using bows to launch arrows with deadly accuracy from a distance.                                              ",
		"Crossbows: Handle crossbows, powerful ranged weapons that can deliver devastating bolts to penetrate even the toughest armor.                   ",
		"Hands: Refine your unarmed combat skills, unleashing a flurry of punches, kicks, and grapples to overpower your opponents.                      ",
		"One-handed: Develop proficiency in wielding one-handed weapons, granting you versatility in combat with a free hand for defense or utility.     ",
		"Two-handed: Embrace the raw power of massive two-handed weapons like greatswords and battle axes, obliterating foes with mighty strikes.        ",
		"Precision: Cultivate your precision, increasing your chances of landing critical hits and striking vital points for maximum damage.             ",
		"Thrust: Focus on the art of thrusting attacks, gaining the ability to pierce armor and penetrate deep into your adversaries' defenses.          ",
		"Athletics: Strengthen your physical prowess, enhancing your speed, stamina, and agility for swift maneuvers and resilience in combat.           ",
		"Equitation: Master the art of horse riding, enabling you to swiftly navigate the battlefield and engage enemies from mounted advantage.         ",
		"Tactics: Develop strategic thinking and decision-making skills, enabling you to plan your actions and exploit your enemies' weaknesses.         ",
		"Skirmish: Become adept in hit-and-run tactics, excelling in quick engagements where mobility, agility, and surprise are key to victory.         ",
		"Fire Magic: Harness the power of flames, incinerating foes and wreaking havoc with infernal spells, but beware not to harm yourself.            ",
		"Water Magic: Manipulate the currents of water and create it from the void, casting torrents and freezing enemies with chilling precision.       ",
		"Earth Magic: Command the strength of the earth, crushing adversaries with seismic shocks and sturdy defenses.                                   ",
		"Wind Magic: Control the swift breeze, unleashing gusts and tearing through enemies with razor-sharp projectiles or increase your speed.         ",
		"Nature Magic: Channel the essence of the natural world, nurturing allies and summoning creatures of the wilderness.                             ",
		"Venom Magic: Inflict deadly toxins and poisons, weakening enemies and watching them succumb to vile venom, or weaken them and run away.         ",
		"Shadow Magic: Embrace the darkness, concealing yourself in the shadows and draining life energy with sinister shadow spells.                    ",
		"Bone Magic: Manipulate the skeletal remnants of the deceased, raising undead minions and casting bone-shattering spells or healing ones.        ",
		"Rune Magic: Inscribe and activate ancient runes, unleashing elemental forces and unraveling unseen and destructive ancient magical barriers.    ",
		"Puppet Magic: Seize control of minds, bending the will of your enemies and forcing them to do your bidding or create a puppet to do it.         ",
		"Summon Magic: Conjure ethereal allies and mythical creatures, bolstering your forces and overwhelming your foes.                                ",
		"Insect Magic: Command swarms of insects, inflicting agonizing stings and unleashing plague-like devastation, making allies of former foes.      ",
		"Ritual Magic: Perform intricate and powerful sacrificial rituals to exchange life force for items, magic, scrolls, gold or power.               ",
		"Rot Magic: Embrace decay and putrefaction, corroding the flesh of your enemies and spreading pestilence and plague.                             ",
		"Taboo Magic: Seek forbidden arts, delving into dark rituals and wielding forbidden spells with dire consequences, but be very careful.          ",
		"Abyss Magic: Harness the eldritch forces from the depths of the abyss, unraveling reality and engulfing enemies in chaos.                       ",
		"Wisdom: Acquire profound knowledge and insight to navigate challenges wisely.                                                                   ",
		"Patience: Endure and persevere through trials with calmness and resilience.                                                                     ",
		"Religion: Channel divine power through faith and devotion to overcome obstacles.                                                                ",
		"Speech: Persuasively communicate thoughts and ideas, influencing others effectively.                                                            ",
		"Reflection: Engage in self-analysis, learning from experiences for personal growth.                                                             ",
		"Refraction: Bend and manipulate the flow of energy to alter its course.                                                                         ",
		"Authority: Command respect, possess leadership skills, and wield influence.                                                                     ",
		"Deception: Master the art of trickery and illusion to deceive opponents cunningly.                                                              ",
		"Life Force: Harness the essence of vitality to sustain and strengthen oneself.                                                                  ",
		"Mana Force: Manipulate and control magical energy for various purposes.                                                                         ",
		"Regeneration: Restore health and vitality gradually and naturally over time.                                                                    ",
		"Restoration: Mend and heal wounds, restoring physical and spiritual well-being.                                                                 ",
		"Spellcraft: Master the intricate art of casting spells with precision and expertise.                                                            ",
		"Protection: Shield oneself and allies, providing defense against harm and danger.                                                               ",
		"Synthesis: Combine elements harmoniously, creating powerful and synergistic effects.                                                            ",
		"Evocation: Summon and command mystical forces, unleashing their power and potential.                                                            ",
		"Medicine: Heal wounds and cure ailments, preserving health and vitality.                                                                        ",
		"Mercantile: Master the art of trade and negotiation, obtaining valuable resources and goods.                                                    ",
		"Education: Expand knowledge and gain expertise in various subjects, unlocking new possibilities.                                                ",
		"Navigation: Navigate through treacherous terrains, uncovering hidden paths and shortcuts.                                                       ",
		"Conjuration: Summon and command ethereal beings and objects to aid in battle and exploration.                                                   ",
		"Alteration: Manipulate and reshape the physical world, bending it to your will.                                                                 ",
		"Enchantment: Infuse objects with magical properties, enhancing their abilities and powers.                                                      ",
		"Teleportation: Instantly transport yourself across distances, bypassing obstacles and traps.                                                    ",
		"Astronomy: Study celestial bodies and their movements, unlocking celestial insights and abilities.                                              ",
		"Occultism: Harness forbidden knowledge and practices, tapping into dark and mysterious forces.                                                  ",
		"Mysticism: Connect with spiritual realms, accessing mystical powers and ancient wisdom.                                                         ",
		"Survival: Thrive in harsh environments, utilizing nature's resources and adapting to challenges.                                                ",
		"Evasion: Evade and dodge attacks with exceptional reflexes and agility.                                                                         ",
		"Stealth: Move silently and remain undetected, infiltrating enemy territories with stealth and precision.                                        ",
		"Detection: Uncover hidden secrets and traps, perceive hidden objects and enemies.                                                               ",
		"Identification: Identify and analyze unknown items and artifacts, revealing their true nature and potential.                                    ",
		"Blacksmith: Master the art of forging and shaping metals, crafting powerful weapons and armor.                                                  ",
		"Whitesmith: Refine and enhance crafted items, imbuing them with special properties and bonuses.                                                 ",
		"Light Craft: Create delicate and intricate objects, such as jewelry and trinkets, with finesse and precision.                                   ",
		"Heavy Craft: Construct robust and durable structures, fortifying defenses and creating formidable tools.                                        ",
		"Light Works: Skillfully manipulate light and optics, creating illusions and harnessing blinding brilliance.                                     ",
		"Heavy Works: Command elemental forces and harness their raw power, shaping them for destruction or creation.                                    ",
		"Leather: Tame and work with animal hides, fashioning resilient armor and accessories.                                                           ",
		"Construction: Design and erect structures, fortresses, and defenses in an efficient and strategic manner.                                       ",
		"Weapons: Wield a wide array of lethal weapons, mastering various combat styles and techniques.                                                  ",
		"Armours: Forge resilient armor and protective gear, shielding against incoming threats and attacks.                                             ",
		"Engineer: Innovate and create mechanical wonders, building intricate contraptions and mechanisms.                                               ",
		"Alchemy: Transmute and brew potent elixirs and potions, unlocking the power of transformative substances.                                       ",
		"Ritual: Perform ancient rituals, invoking otherworldly energies to manipulate reality itself.                                                   ",
		"Experience: Draw upon accumulated knowledge and insights, gaining wisdom and enhancing abilities.                                               ",
		"Necromancy: Command the forces of death and undeath, bending the deceased to your will.                                                         ",
		"Reincarnation: Manipulate the cycle of life and death, granting second chances and renewed existence.                                           "
	);

	title_info : constant array (title_list) of core.description := (
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                ",
		"                                                                                                                                                "
	);

                                             ------------------------------------------------------------------------------------------

end game;
