------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package monster is

                                             ------------------------------------------------------------------------------------------

	type list is (
		goblin_slave,       goblin_worker,      goblin_warrior,     goblin_boar_rider,  goblin_shaman,      goblin_chief,       goblin_king,        goblin_ogre
	);

	type mark is mod 72;

                                             ------------------------------------------------------------------------------------------

	type constant_type is new core.constant_type with
	record
		attack_range : natural := 0;
	end record;

	type variable_type is new core.variable_type with
	record
		soul   : core.soul_type;
		health : core.health_type;
		mana   : core.mana_type;
	end record;

	type constant_list is array (list) of constant_type;
	type variable_list is array (mark) of variable_type;

                                             ------------------------------------------------------------------------------------------

	constant_data : constant constant_list := (
		(core.monster, "Goblin Slave        ", 'S', core.colour.green, core.effect.bold,  2),
		(core.monster, "Goblin Worker       ", 'R', core.colour.green, core.effect.bold,  3),
		(core.monster, "Goblin Warrior      ", 'W', core.colour.green, core.effect.bold,  5),
		(core.monster, "Goblin Boar Rider   ", 'B', core.colour.green, core.effect.bold, 11),
		(core.monster, "Goblin Shaman       ", 'H', core.colour.green, core.effect.bold,  3),
		(core.monster, "Goblin Chief        ", 'C', core.colour.green, core.effect.bold,  7),
		(core.monster, "Goblin King         ", 'K', core.colour.green, core.effect.bold, 13),
		(core.monster, "Goblin Ogre         ", 'O', core.colour.green, core.effect.bold, 23)
	);

	variable_data : variable_list;

                                             ------------------------------------------------------------------------------------------

	procedure generate;
	procedure render;

                                             ------------------------------------------------------------------------------------------

end monster;
