------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Copyright (c) 2023 - Ognjen 'xolatile' Milan Robovic
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Xabina is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either
-- version 3 of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-- implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

with core;

package plant is

                                             ------------------------------------------------------------------------------------------

	type list is (
		oak_tree,           pine_tree,          birch_tree,         acacia_tree,        apple_tree,         peach_tree,         orange_tree,        pear_tree,
		bush,               thorny_bush,        tall_grass,         reed
	);

	type mark is mod 72;

                                             ------------------------------------------------------------------------------------------

	type constant_type is new core.constant_type with
	record
		health_limit : natural := 0;
	end record;

	type variable_type is new core.variable_type with
	record
		health : natural := 0;
	end record;

	type constant_list is array (list) of constant_type;
	type variable_list is array (mark) of variable_type;

                                             ------------------------------------------------------------------------------------------

	constant_data : constant constant_list := (
		(core.plant, "Oak Tree            ", 'T', core.colour.green, core.effect.bold,   11),
		(core.plant, "Pine Tree           ", 'T', core.colour.green, core.effect.bold,   23),
		(core.plant, "Birch Tree          ", 'T', core.colour.green, core.effect.bold,   13),
		(core.plant, "Acacia Tree         ", 'T', core.colour.green, core.effect.bold,   19),
		(core.plant, "Apple Tree          ", 'T', core.colour.green, core.effect.bold,   17),
		(core.plant, "Peach Tree          ", 'T', core.colour.green, core.effect.bold,   13),
		(core.plant, "Orange Tree         ", 'T', core.colour.green, core.effect.bold,   11),
		(core.plant, "Pear Tree           ", 'T', core.colour.green, core.effect.bold,   13),
		(core.plant, "Bush                ", '&', core.colour.green, core.effect.normal,  5),
		(core.plant, "Thorny Bush         ", '&', core.colour.green, core.effect.normal,  7),
		(core.plant, "Tall Grass          ", '%', core.colour.green, core.effect.normal,  3),
		(core.plant, "Reed                ", '%', core.colour.green, core.effect.normal,  3)
	);

	variable_data : variable_list;

                                             ------------------------------------------------------------------------------------------

	procedure generate;
	procedure render;

                                             ------------------------------------------------------------------------------------------

end plant;
